<?php
$isMaster = $this->environment()->getClient()->isMaster();
?>

<div ng-controller="financerController as self"
     ng-init="self.initQueries()">
    <?php if ($this->acl()->isAllowed('application:e:query:r')): ?>
        <div class="row">
            <div class="col-md-4 col-md-offset-8">
                <div class="queries-toggler little-panel">
                    <div href="#queries-collapsed-node-tree-financer"
                         data-toggle="collapse"
                         class="title">
                        <i class="fa fa-shopping-basket fa-fw"></i>
                        Requêtes
                    </div>

                    <div id="queries-collapsed-node-tree-financer"
                         class="body collapse">
                        <div ng-if="self.loadingQueries"
                             class="text-center">
                            <i class="fa fa-spin fa-circle-o-notch"></i>
                        </div>

                        <ul class="list-unstyled">
                            <li ng-repeat="query in self.queries">
                                <a ng-click="self.loadQuery(query)"
                                   class="pointer">
                                    <i ng-if="query.shared" class="fa fa-share-alt"></i> {{ query.name }}
                                </a>

                                <i ng-click="self.deleteQuery(query)" ng-if="query._rights.delete"
                                   tooltip="Supprimer"
                                   class="fa fa-trash pointer pull-right">
                                </i>
                            </li>
                        </ul>

                        <form ng-submit="self.saveQuery()"
                              name="queryForm">
                            <div class="input-group input-group-sm">
                                <input ng-model="self.query.name"
                                       placeholder="Nom de la requête"
                                       type="text"
                                       class="form-control"
                                       required/>

                                <span class="input-group-btn">
                                    <?php if (!$this->acl()->onlyOwned('application:e:query:r') && !$this->acl()->onlyOwned('application:e:query:u')) : ?>
                                        <label class="checkbox-inline" style="margin: 0 10px">
                                            <input type="checkbox" ng-model="self.query.shared"/>
                                            Partagée ?
                                        </label>
                                    <?php endif; ?>

                                    <button ng-disabled="self.loadingSaveQuery"
                                            type="submit"
                                            class="btn btn-submit">
                                        <i ng-if="self.loadingSaveQuery"
                                           class="fa fa-spin fa-circle-o-notch">
                                        </i>
                                        Enregistrer
                                    </button>
                                </span>
                            </div>

                            <field-errors field="name"
                                          errors="errors.fields">
                            </field-errors>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    <?php endif ?>
    <div class="row">
        <div class="col-md-4">
            <div ng-controller="projectFilterController as filter"
                 ng-init="filter.init('project')"
                 class="table-filters little-panel">
                <div class="title" data-toggle="collapse" href="#filters-collapsed-financer-project">
                    <?= $this->icon('filters', 'fa-fw') ?>
                    <?= $this->translate('filters') ?>
                    <?= ucfirst($this->translate('project_entity')) ?>
                </div>
                <div id="filters-collapsed-financer-project" class="body collapse project">
                    <?= $this->tableFilter('self.filters.project', $this->projectFilters($isMaster ? ['networkAccessible', 'managers', 'validators', 'members', 'actors', 'ownership', 'parent', 'financer', 'financer', 'level', 'budgetStatus'] : ['financer'])); ?>
                </div>
            </div>
        </div>
        <div class="col-md-4">
            <div ng-controller="filterController as filter"
                 ng-init="filter.init('structure')"
                 class="table-filters little-panel">
                <div class="title" data-toggle="collapse" href="#filters-collapsed-financer-financer">
                    <?= $this->icon('filters', 'fa-fw') ?>
                    <?= $this->translate('filters') ?>
                    <?= ucfirst($this->translate('envelope_field_financer')) ?>
                </div>
                <div id="filters-collapsed-financer-financer" class="body collapse">
                    <?= $this->tableFilter('self.filters.structure', $this->structureFilters($isMaster ? ['financer', 'job', 'contact'] : ['financer'])); ?>
                </div>
            </div>
        </div>
        <div class="col-md-4">
            <div ng-controller="filterController"
                 class="table-filters little-panel">
                <div class="title" data-toggle="collapse" href="#filters-collapsed-financer-group">
                    <?= ucfirst($this->translate('group_by')) ?>
                </div>
                <div id="filters-collapsed-financer-group" class="body collapse">
                    <select class="form-control" ng-model="self.filters.group">
                        <option value="financer">
                            <?= ucfirst($this->translate('envelope_field_financer')) ?>
                        </option>
                        <?php if ($this->module()->isActive('keyword')) : ?>
                            <option value="keyword">
                                <?= ucfirst($this->translate('keyword_entity')) ?>
                            </option>
                        <?php endif ?>
                    </select>
                </div>
            </div>
        </div>
    </div>
    <div class="row separator">
        <div class="col-md-4 col-md-offset-4">
            <div class="row">
                <div class="col-xs-6">
                    <button class="btn" ng-click="self.resetFilters();">
                        <?= $this->translate('table_filter_reset_button') ?>
                    </button>
                </div>
                <div class="col-xs-6 text-right">
                    <button class="btn" ng-click="self.applyFilters();">
                        <?= $this->icon('search', 'fa-fw') ?>
                        <?= $this->translate('table_filter_button') ?>
                    </button>
                </div>
            </div>
        </div>
    </div>
    <div class="row separator" ng-if="self.loading">
        <div class="col-xs-12 text-center">
            <?= $this->icon('loading') ?>
        </div>
    </div>
    <div class="row" ng-if="self.getProjectsNumber() > 0">
        <div class="col-sm-12">
            <div class="pull-left">
                <?= $this->translate('number_project') ?>
            </div>
            <div class="btn-group pull-right">
                <button class="btn btn-excel"
                        type="button"
                        ng-click="self.export()"
                        tooltip="<?= $this->translate('tooltip_export_xls') ?>">
                    <?= $this->icon('excel', 'fa-fw pointer') ?>
                </button>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12">
            <div class="table-scroller">
                <table class="table table-bordered table-condensed table-hover">
                    <thead>
                        <tr>
                            <?php if ($isMaster) : ?>
                                <th>
                                    <?= ucfirst($this->translate('client_entity')) ?>
                                </th>
                            <?php endif; ?>
                            <th>
                                <?= ucfirst($this->translate('project_field_code')) ?>
                            </th>
                            <th>
                                <?= ucfirst($this->translate('project_entity')) ?>
                            </th>
                            <?php
                            foreach (\Budget\Entity\Income::getTypes() as $type) {
                                echo '<th colspan="{{self.getColspan(\'' . $type . '\')}}">' . $this->translate('income_type_' . $type) . '</th>';
                            }
                            ?>
                        </tr>
                        <tr>
                            <?php if ($isMaster) : ?>
                            <th></th>
                            <?php endif; ?>
                            <th></th>
                            <th></th>
                            <?php foreach (\Budget\Entity\Income::getTypes() as $type) : ?>
                            <th ng-repeat="financer in self.financers" ng-if="!self.columnEmpty(financer, '<?= $type ?>')">
                                {{financer.name}}
                            </th>
                            <?php endforeach; ?>
                        </tr>
                    </thead>
                    <tbody <?= $isMaster ? 'ng-repeat="(client, projects) in self.projects | groupBy: \'_client.name\' "' : '' ?>>
                        <?php if ($isMaster) : ?>
                        <tr ng-click="_client.open = !_client.open" class="group pointer">
                            <td>
                                <i class="fa" ng-class="{
                                    'fa-caret-right': !_client.open,
                                    'fa-caret-down': _client.open
                                }"></i>
                                {{client}}
                            </td>
                            <td></td>
                            <td></td>
                            <?php foreach (\Budget\Entity\Income::getTypes() as $type) : ?>
                                <td ng-repeat="financer in self.financers" class="text-right" ng-if="!self.columnEmpty(financer, '<?= $type ?>')">
                                    {{self.getPartialTotal(projects[0]._client.id, financer._client.id + '_' + financer.id, '<?= $type ?>') | currency : ''}} €
                                </td>
                            <?php endforeach; ?>
                        </tr>
                        <?php endif; ?>
                        <tr ng-repeat="project in <?= $isMaster ? 'projects' : 'self.projects'?>"
                            <?= $isMaster ? 'ng-show="_client.open"' : '' ?>>
                            <?php if ($isMaster) : ?>
                                <td></td>
                            <?php endif; ?>
                            <td>
                                {{ project.code }}
                            </td>
                            <td>
                                <a ng-if="project._rights.read" href="<?= $this->url('project/form') ?>/{{ project.id }}">{{ project.name }}</a>
                            </td>
                            <?php foreach (\Budget\Entity\Income::getTypes() as $type) : ?>
                                <td ng-repeat="financer in self.financers" class="text-right" ng-if="!self.columnEmpty(financer, '<?= $type ?>')">
                                    {{project.data[financer._client.id + '_' + financer.id].<?= $type ?> || 0 | currency : ''}} €
                                </td>
                            <?php endforeach; ?>
                        </tr>
                    </tbody>
                    <tfoot>
                        <tr class="footer">
                            <?php if ($isMaster) : ?>
                                <td></td>
                            <?php endif; ?>
                            <td></td>
                            <td></td>
                            <?php foreach (\Budget\Entity\Income::getTypes() as $type) : ?>
                                <td ng-repeat="financer in self.financers" class="text-right" ng-if="!self.columnEmpty(financer, '<?= $type ?>')">
                                    {{ financer.data.<?= $type ?> || 0 | currency : ''}} €
                                </td>
                            <?php endforeach; ?>
                        </tr>
                    </tfoot>
                </table>
            </div>
        </div>
    </div>
</div>
